/*
    SIT - SIS is tiny, intended to be a IRC Client for secure communication
	on top of the IRC protocol as described in RFC 1459
    Copyright (C) 2000  Christian Leber

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    e-mail: c_l@bigfoot.com
    I hope this is GPL compliant, if not please contact me.
*/


#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include "out.h"

/*
out_dest: if it's 1 than this is stdout
out_protokoll:
	-"1"  it's for SIT in raw mode
	-"11" is for the first series of frontends
*/


/*
type=0  unspecific
*/
void out_server(int out_protocol,int type,char *mess)
{
	/* channel message */
	if(type==0)
	{
		if(out_protocol==1)
			out_to_system("%s",mess);
		else if(out_protocol==11)
			out_to_system("%s",mess);
	}
}

/*
type=0  unspecific
this is temporarily stuff!!!
*/
void out_raw(int out_protocol,char *mess)
{
	if(out_protocol==1)
		out_to_system("%s",mess);
	else if(out_protocol==11)
		out_to_system("%s",mess);
}


/*
type=1  Standard Channel Message
type=2  Private Message (call is Query ;))
*/
void out_pm(int out_protocol,int type,char *from,char *to,char *mess)
{
	/* channel message */
	if(type==1)
	{
		if(out_protocol==1)
			out_to_system("[%s]: %s",from,mess);
		else if(out_protocol==11)
			out_to_system("[%s]: %s",from,mess);
	}
	else if(type==2)
	{
		if(out_protocol==1)
			out_to_system("PRIVMSG from %s: %s",from,mess);
		else if(out_protocol==11)
			out_to_system("PRIVMSG from %s: %s",from,mess);
	}
}

void out_notice(int out_protocol,int type,char *from,char *mess)
{
	if(type==1)
	{
		if(out_protocol==1)
			out_to_system("<< %s >>: %s",from,mess);
		else if(out_protocol==11)
			out_to_system("<< %s >>: %s",from,mess);
	}
}

void out_to_system(char *format, ...)
{
	char *buff1; /* general buffer... you know that :)) */
	int retval=0; /* return value from snprintf */
	va_list arg_list;
	
	buff1 = (char *)malloc(1025);

	va_start(arg_list, format);
	retval=vsnprintf(buff1,1024,format,arg_list);
	va_end(arg_list);
	
	if(retval==-1 || retval>=1024)
	{
		printf("%s\n", "ERROR: shitt happens in SIT_printf_to_tcpSend;\
		 	to much stuff for the buffer");
		return;
	}
	/* possibly could be replaces with write or so */
	printf("%s\n",buff1);
}
