#!/usr/bin/wish -f
# TkSit - The TK GUI for SIT 

wm title . TkSit

frame .top -borderwidth 3
pack .top -side top -fill x

# Create the Run it Button. 
set but [button .top.run -text "Run it" -command Run]
pack .top.run -side right

# Create a labeled entry for the command 
label .top.l -text Command: -padx 0 
entry .top.cmd -width 20 -relief sunken\
-textvariable command 
pack .top.l -side left 
pack .top.cmd -side left -fill x -expand true 
# Set up key binding equivalents to the buttons 
.top.cmd insert 0 "../sit -n ijut"
bind .top.cmd <Return> Run
focus .top.cmd

# Create a text widget to log the output 
frame .t
set log [text .t.log -width 80 -height 10\
-borderwidth 2 -relief raised -setgrid true\
-yscrollcommand {.t.scroll set}]
scrollbar .t.scroll -command {.t.log yview} 
pack .t.scroll -side right -fill y 
pack .t.log -side left -fill both -expand true
pack .t -side top -fill both -expand true


# Create a frame for the input thing
frame .bottom -borderwidth 0
pack .bottom -side top -fill x
entry .bottom.cmd2 -width 20 -relief sunken\
-textvariable command2
pack .bottom.cmd2 -side left -fill x -expand true


# Run the program and arrange to read its input 
proc Run {} { 
	global command input log but
	if [catch {open "|$command" "r+"} input] { 
		$log insert end $input\n 
	} else {
	fconfigure $input -buffering line

	bind .bottom.cmd2 <Return> Run2
	focus .bottom.cmd2
	fileevent $input readable Log 
	$log insert end $command\n 
	$but config -text Stop -command StopSIT
	}
} 

proc Run2 {} { 
	global command2 input log but 
	puts $input $command2
	
	$log insert end $command2\n 
	$log see end
	
	.bottom.cmd2 delete 0 end
} 


# Read and log output from the program 
proc Log {} { 
global input log 
if [eof $input] { 
StopSIT 
} else { 
gets $input line 
$log insert end $line\n 
$log see end 
} 
} 

# Stop the program and fix up the button 
proc StopSIT {} { 
global input but
puts $input "/quit"
catch {close $input} 
$but config -text "Run it" -command Run 
bind .top.cmd <Return> Run
focus .top.cmd
} 
